//34567890123456789012345678901234567890123456789012345678
import greenfoot.*;

/**
 * This class demonstrates how to create and use a text
 * box instanted from the Actor class named TextBoxB. The
 * text box is positioned in the world on the basis of the
 * values of the two corner variables.
 * 
 * @author Dick Baldwin 
 * @version 07/13/08
 */
public class Tester extends Actor 
                               implements TextBoxListener{
  TextBoxB textBox;
  boolean textBoxAdded = false;
  int upperLeftCornerX = 10;
  int upperLeftCornerY = 20;
  
  public Tester(){
    //Any text that you put in the text box when it is
    // constructed will be replaced by user input
    // characters.
    textBox = new TextBoxB("",//initial text
                          20,//point size for text
                          this);//used for callback
    //Make the object of this class invisible.
    setImage(new GreenfootImage(1,1));//invisible
  }//end constructor
  //----------------------------------------------------//
  
  public void act(){
    //Note that the Tester actor cannot add the text box
    // or the label that represents the text box to the
    // world when the Tester is being constructed.
    // Therefore, it is necessary to either include that
    // code in the constructor for the world, or cause
    // the Tester to add the text box and the label to the
    // world after the Tester has been constructed. This
    // is one way to do that, but there may be better
    // ways.
    if(textBoxAdded == false){
      //Execute the body of this if-statement once and
      // only once.
      //Add the TextBox object to the upper-left corner of
      // the world. It is a one-pixel transparent square.
      getWorld().addObject(textBox,0,0);
      //Add the label that represents the text box to the
      // world at the location specified by the two
      // corner variables above.
      Labels label = textBox.getTextBoxLabel();
      getWorld().addObject(label,
                  upperLeftCornerX + label.getWidth()/2,
                  upperLeftCornerY + label.getHeight()/2);
      //Set a flag to skip this code from now on.
      textBoxAdded = true;
    }//end if
/*This is one of two optional ways to retrieve the text
 * from the text box. The other way is to service the
 * callback method.
    
    //Get and display the text from the text box when it
    // is ready. The getText method will return null until
    // the user strokes the Enter key to signal that the
    // text string is ready for use.
    String text = textBox.getText();
    if(text != null){
      //Note that the text box is cleared and made ready
      // for the entry of new text when a non-null value
      // is returned from the getText method.
      System.out.println(text);
    }//end if
*/
  }//end act
  //----------------------------------------------------//
  
  //This method is called when the user strokes the
  // Enter key. The contents of the text box at that time
  // are passed as a parameter to the method
  public void callback(TextBoxB source){
    System.out.println(source.getText());
  }//end callback
}//end class Tester
